Index: trunk/NEMOGCM/NEMO/OFF_SRC/opa.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OFF_SRC/opa.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OFF_SRC/opa.F90	(revision 2528)
@@ -1,33 +1,41 @@
 MODULE opa
-   !!==============================================================================
+   !!======================================================================
    !!                       ***  MODULE opa   ***
-   !! Ocean system   : OPA ocean dynamics (including on-line tracers and sea-ice)
-   !!==============================================================================
-
-   !!----------------------------------------------------------------------
-   !!   opa_model      : solve ocean dynamics, tracer and/or sea-ice
-   !!----------------------------------------------------------------------
-   !! * Modules used
+   !! Off-line Ocean   : passive tracer evolution, dynamics read in files
+   !!======================================================================
+   !! History :  3.3  ! 2010-05  (C. Ethe)  Full reorganization of the off-line: phasing with the on-line
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   opa_model      : off-line: solve ocean tracer only
+   !!   opa_init       : initialization of the opa model
+   !!   opa_ctl        : initialisation of algorithm flag 
+   !!   opa_closefile  : close remaining files
+   !!----------------------------------------------------------------------
    USE dom_oce         ! ocean space domain variables
    USE oce             ! dynamics and tracers variables
-   USE in_out_manager  ! I/O manager
-   USE lib_mpp         ! distributed memory computing
-
+   USE c1d             ! 1D configuration
    USE domcfg          ! domain configuration               (dom_cfg routine)
-   USE mppini          ! shared/distributed memory setting (mpp_init routine)
    USE domain          ! domain initialization             (dom_init routine)
    USE istate          ! initial state setting          (istate_init routine)
    USE eosbn2          ! equation of state            (eos bn2 routine)
-
-   ! ocean physics
-   USE ldftra          ! lateral diffusivity setting    (ldftra_init routine)
-   USE traqsr          ! solar radiation penetration   (tra_qsr_init routine)
-
+   !              ! ocean physics
+   USE ldftra          ! lateral diffusivity setting    (ldf_tra_init routine)
+   USE ldfslp          ! slopes of neutral surfaces     (ldf_slp_init routine)
+   USE traqsr          ! solar radiation penetration    (tra_qsr_init routine)
+   USE trabbl          ! bottom boundary layer          (tra_bbl_init routine)
+   USE zdfini          ! vertical physics: initialization
    USE phycst          ! physical constant                  (par_cst routine)
    USE dtadyn          ! Lecture and Interpolation of the dynamical fields
    USE trcini          ! Initilization of the passive tracers
-   USE step            ! OPA time-stepping                  (stp     routine)
-
-   USE iom
+   USE daymod          ! calendar                         (day     routine)
+   USE trcstp          ! passive tracer time-stepping      (trc_stp routine)
+   USE dtadyn          ! Lecture and interpolation of the dynamical fields
+   USE stpctl          ! time stepping control            (stp_ctl routine)
+   !              ! I/O & MPP
+   USE iom             ! I/O library
+   USE in_out_manager  ! I/O manager
+   USE mppini          ! shared/distributed memory setting (mpp_init routine)
+   USE lib_mpp         ! distributed memory computing
 #if defined key_iomput
    USE  mod_ioclient
@@ -36,18 +44,14 @@
    IMPLICIT NONE
    PRIVATE
-
-   !! * Module variables
-   CHARACTER (len=64) ::        &
-      cform_aaa="( /, 'AAAAAAAA', / ) "     ! flag for output listing
-
-   !! * Routine accessibility
-   PUBLIC opa_model      ! called by model.F90
-   PUBLIC opa_init
-   !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL  (2005)
-   !!   $Id$
-   !!   This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
-   !!----------------------------------------------------------------------
-
+   
+   PUBLIC   opa_model   ! called by model.F90
+
+   CHARACTER (len=64) ::   cform_aaa="( /, 'AAAAAAAA', / ) "   ! flag for output listing
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OFF 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -60,11 +64,11 @@
       !!
       !! ** Method  : - model general initialization
-      !!              - launch the time-stepping (stp routine)
-      !!
-      !! References :
-      !!      Madec, Delecluse,Imbard, and Levy, 1997: reference manual.
-      !!              internal report, IPSL.
-      !!----------------------------------------------------------------------
-      INTEGER ::   istp       ! time step index
+      !!              - launch the time-stepping (dta_dyn and trc_stp)
+      !!              - finalize the run by closing files and communications
+      !!
+      !! References : Madec, Delecluse,Imbard, and Levy, 1997:  internal report, IPSL.
+      !!              Madec, 2008, internal report, IPSL.
+      !!----------------------------------------------------------------------
+      INTEGER :: istp, indic       ! time step index
       !!----------------------------------------------------------------------
 
@@ -77,16 +81,24 @@
       IF( lk_mpp )   CALL mpp_max( nstop )
 
+      !                            !-----------------------!
+      !                            !==   time stepping   ==!
+      !                            !-----------------------!
       istp = nit000
          !
-      DO WHILE ( istp <= nitend .AND. nstop == 0 )
-         CALL stp( istp )
+      DO WHILE ( istp <= nitend .AND. nstop == 0 )    ! time stepping
+         !
+         IF( istp /= nit000 )   CALL day      ( istp )         ! Calendar (day was already called at nit000 in day_init)
+                                CALL iom_setkt( istp )         ! say to iom that we are at time step kstp
+                                CALL dta_dyn  ( istp )         ! Interpolation of the dynamical fields
+                                CALL trc_stp  ( istp )         ! time-stepping
+                                CALL stp_ctl  ( istp, indic )  ! Time loop: control and print
          istp = istp + 1
          IF( lk_mpp )   CALL mpp_max( nstop )
       END DO
-      !                                     ! ========= !
-      !                                     !  Job end  !
-      !                                     ! ========= !
-
-      IF(lwp) WRITE(numout,cform_aaa)       ! Flag AAAAAAA
+
+      !                            !------------------------!
+      !                            !==  finalize the run  ==!
+      !                            !------------------------!
+      IF(lwp) WRITE(numout,cform_aaa)                 ! Flag AAAAAAA
 
       IF( nstop /= 0 .AND. lwp ) THEN                 ! error print
@@ -94,7 +106,7 @@
          WRITE(numout,*) nstop, ' error have been found'
       ENDIF
-
+      !
       CALL opa_closefile
-
+      !
       IF( lk_mpp )   CALL mppstop                          ! Close all files (mpp)
       !
@@ -106,186 +118,140 @@
       !!                     ***  ROUTINE opa_init ***
       !!
-      !! ** Purpose :   opa solves the primitive equations on an orthogonal 
-      !!      curvilinear mesh on the sphere.
-      !!
-      !! ** Method  : - model general initialization
-      !!
-      !! References :
-      !!      Madec, Delecluse,Imbard, and Levy, 1997: reference manual.
-      !!              internal report, IPSL.
-      !!
-      !! History :
-      !!   4.0  !  90-10  (C. Levy, G. Madec)  Original code
-      !!   7.0  !  91-11  (M. Imbard, C. Levy, G. Madec)
-      !!   7.1  !  93-03  (M. Imbard, C. Levy, G. Madec, O. Marti,
-      !!                   M. Guyon, A. Lazar, P. Delecluse, C. Perigaud,
-      !!                   G. Caniaux, B. Colot, C. Maes ) release 7.1 
-      !!        !  92-06  (L.Terray) coupling implementation
-      !!        !  93-11  (M.A. Filiberti) IGLOO sea-ice 
-      !!   8.0  !  96-03  (M. Imbard, C. Levy, G. Madec, O. Marti,
-      !!                   M. Guyon, A. Lazar, P. Delecluse, L.Terray,
-      !!                   M.A. Filiberti, J. Vialar, A.M. Treguier,
-      !!                   M. Levy)  release 8.0
-      !!   8.1  !  97-06  (M. Imbard, G. Madec)
-      !!   8.2  !  99-11  (M. Imbard, H. Goosse)  LIM sea-ice model 
-      !!        !  99-12  (V. Thierry, A-M. Treguier, M. Imbard, M-A. Foujols)  OPEN-MP 
-      !!        !  00-07  (J-M Molines, M. Imbard)  Open Boundary Conditions  (CLIPPER)
-      !!   9.0  !  02-08  (G. Madec)  F90: Free form and modules
-      !!----------------------------------------------------------------------
-      !! * Local declarations
+      !! ** Purpose :   initialization of the opa model in off-line mode
+      !!----------------------------------------------------------------------
+      INTEGER ::   ji            ! dummy loop indices
+      INTEGER ::   ilocal_comm   ! local integer
+      CHARACTER(len=80), DIMENSION(10) ::   cltxt = ''
+      !!
+      NAMELIST/namctl/ ln_ctl  , nn_print, nn_ictls, nn_ictle,   &
+         &             nn_isplt, nn_jsplt, nn_jctls, nn_jctle, nn_bench
+      !!----------------------------------------------------------------------
+      !
+      !                             ! open Namelist file     
+      CALL ctl_opn( numnam, 'namelist', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE. )
+      !
+      READ( numnam, namctl )        ! Namelist namctl : Control prints & Benchmark
+      !
+      !                             !--------------------------------------------!
+      !                             !  set communicator & select the local node  !
+      !                             !--------------------------------------------!
 #if defined key_iomput
-      INTEGER :: localComm
+      CALL init_ioclient( ilocal_comm )       ! nemo local communicator (used or not) given by the io_server
+      narea = mynode( cltxt, ilocal_comm )    ! Nodes selection
+#else
+      narea = mynode( cltxt )                 ! Nodes selection (control print return in cltxt)
 #endif
-      CHARACTER (len=20) ::   namelistname
-      CHARACTER (len=28) ::   file_out
-      NAMELIST/namctl/ ln_ctl, nprint, nictls, nictle,   &
-         &             isplt , jsplt , njctls, njctle, nbench
-
-      !!----------------------------------------------------------------------
-
-      ! Initializations
-      ! ===============
-
-      file_out = 'ocean.output'
-
-      ! open listing and namelist units
-      CALL ctlopn( numout, file_out, 'UNKNOWN', 'FORMATTED',   &
-         &         'SEQUENTIAL', 1, 6, .FALSE., 1 )
-
-      namelistname = 'namelist'
-      CALL ctlopn( numnam, namelistname, 'OLD', 'FORMATTED', 'SEQUENTIAL',   &
-         &         1, numout, .FALSE., 1 )
-
-      WRITE(numout,*)
-      WRITE(numout,*) '                 L O D Y C - I P S L'
-      WRITE(numout,*) '                     O P A model'
-      WRITE(numout,*) '            Ocean General Circulation Model'
-      WRITE(numout,*) '               version OPA 9.0  (2005) '
-      WRITE(numout,*)
-      WRITE(numout,*)
-
-      ! Namelist namctl : Control prints & Benchmark
-      REWIND( numnam )
-      READ  ( numnam, namctl )
-
-#if defined key_iomput
-      CALL init_ioclient(localcomm)
-      narea = mynode(localComm)
-#else
-      ! Nodes selection
-      narea = mynode()
+      narea = narea + 1                       ! mynode return the rank of proc (0 --> jpnij -1 )
+
+      lwp = (narea == 1) .OR. ln_ctl          ! control of all listing output print
+
+      IF(lwp) THEN                            ! open listing units
+         !
+         CALL ctl_opn( numout, 'ocean.output', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE., narea )
+         !
+         WRITE(numout,*)
+         WRITE(numout,*) '         CNRS - NERC - Met OFFICE - MERCATOR-ocean'
+         WRITE(numout,*) '                       NEMO team'
+         WRITE(numout,*) '            Ocean General Circulation Model'
+         WRITE(numout,*) '                  version 3.3  (2010) '
+         WRITE(numout,*)
+         WRITE(numout,*)
+         DO ji = 1, SIZE(cltxt) 
+            IF( TRIM(cltxt(ji)) /= '' )   WRITE(numout,*) cltxt(ji)      ! control print of mynode
+         END DO
+         WRITE(numout,cform_aaa)                                         ! Flag AAAAAAA
+         !
+      ENDIF
+      !                             !--------------------------------!
+      !                             !  Model general initialization  !
+      !                             !--------------------------------!
+
+      CALL opa_ctl                           ! Control prints & Benchmark
+
+      !                                      ! Domain decomposition
+      IF( jpni*jpnj == jpnij ) THEN   ;   CALL mpp_init      ! standard cutting out
+      ELSE                            ;   CALL mpp_init2     ! eliminate land processors
+      ENDIF
+      !
+      !                                      ! General initialization
+                            CALL     phy_cst    ! Physical constants
+                            CALL     eos_init   ! Equation of state
+                            CALL     dom_cfg    ! Domain configuration
+                            CALL     dom_init   ! Domain
+                            CALL  istate_init   ! ocean initial state (Dynamics and tracers)
+
+      !                                     ! Ocean physics
+#if ! defined key_degrad
+                            CALL ldf_tra_init   ! Lateral ocean tracer physics
 #endif
-
-      ! Nodes selection
-      narea = narea + 1    ! mynode return the rank of proc (0 --> jpnij -1 )
-      lwp   = narea == 1
-
-      ! open additionnal listing
-      IF( ln_ctl )   THEN
-         IF( narea-1 > 0 )   THEN
-            WRITE(file_out,FMT="('ocean.output_',I4.4)") narea-1
-            CALL ctlopn( numout, file_out, 'UNKNOWN', 'FORMATTED',   &
-               &         'SEQUENTIAL', 1, numout, .FALSE., 1 )
-            lwp = .TRUE.
-            !
-            WRITE(numout,*)
-            WRITE(numout,*) '                 L O D Y C - I P S L'
-            WRITE(numout,*) '                     O P A model'
-            WRITE(numout,*) '            Ocean General Circulation Model'
-            WRITE(numout,*) '               version OPA 9.0  (2005) '
-            WRITE(numout,*) '                   MPI Ocean output '
-            WRITE(numout,*)
-            WRITE(numout,*)
-         ENDIF
-      ENDIF
-
-      CALL opa_flg                          ! Control prints & Benchmark
-
-      !                                     ! ============================== !
-      !                                     !  Model general initialization  !
-      !                                     ! ============================== !
+      IF( lk_ldfslp )       CALL ldf_slp_init   ! slope of lateral mixing
+
+      !                                     ! Active tracers
+                            CALL tra_qsr_init   ! penetrative solar radiation qsr
+      IF( lk_trabbl     )   CALL tra_bbl_init   ! advective (and/or diffusive) bottom boundary layer scheme
+
+      !                                     ! Passive tracers
+                            CALL     trc_init   ! Passive tracers initialization
+      !                                     ! Dynamics
+                            CALL dta_dyn_init   ! Initialization for the dynamics
+                            CALL     iom_init       ! iom_put initialization
 
       IF(lwp) WRITE(numout,cform_aaa)       ! Flag AAAAAAA
-
-                                            ! Domain decomposition
-      IF( jpni * jpnj == jpnij ) THEN
-         CALL mpp_init                          ! standard cutting out
-      ELSE
-         CALL mpp_init2                         ! eliminate land processors
-      ENDIF
-      
-      CALL phy_cst                          ! Physical constants
-      CALL eos_init                         ! Equation of state
-      CALL dom_cfg                          ! Domain configuration
-      CALL dom_init                         ! Domain
-      CALL istate_init                      ! ocean initial state (Dynamics and tracers)
-      CALL trc_ini                           ! Passive tracers
-      CALL dta_dyn( nit000 )                 ! Initialization for the dynamics
-      CALL tra_qsr_init                         ! Solar radiation penetration
-#if ! defined key_off_degrad
-      CALL ldf_tra_init                         ! Lateral ocean tracer physics
-#endif 
-      CALL iom_init                         ! iom_put initialization
-
-      IF(lwp) WRITE(numout,cform_aaa)       ! Flag AAAAAAA
-
+      !
    END SUBROUTINE opa_init
 
-   SUBROUTINE opa_flg
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE opa  ***
-      !!
-      !! ** Purpose :   Initialize logical flags that control the choice of
-      !!      some algorithm or control print
-      !!
-      !! ** Method  :    Read in namilist namflg logical flags
-      !!
-      !! History :
-      !!   9.0  !  03-11  (G. Madec)  Original code
-      !!----------------------------------------------------------------------
-      !! * Local declarations
-
-      ! Parameter control and print
-      ! ---------------------------
-      IF(lwp) THEN
+
+   SUBROUTINE opa_ctl
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE opa_ctl  ***
+      !!
+      !! ** Purpose :   control print setting 
+      !!
+      !! ** Method  : - print namctl information and check some consistencies
+      !!----------------------------------------------------------------------
+      !
+      IF(lwp) THEN                  ! Parameter print
          WRITE(numout,*)
          WRITE(numout,*) 'opa_flg: Control prints & Benchmark'
          WRITE(numout,*) '~~~~~~~ '
-         WRITE(numout,*) '          Namelist namctl'
-         WRITE(numout,*) '             run control (for debugging)     ln_ctl    = ', ln_ctl
-         WRITE(numout,*) '             level of print                  nprint    = ', nprint
-         WRITE(numout,*) '             Start i indice for SUM control  nictls    = ', nictls
-         WRITE(numout,*) '             End i indice for SUM control    nictle    = ', nictle
-         WRITE(numout,*) '             Start j indice for SUM control  njctls    = ', njctls
-         WRITE(numout,*) '             End j indice for SUM control    njctle    = ', njctle
-         WRITE(numout,*) '             number of proc. following i     isplt     = ', isplt
-         WRITE(numout,*) '             number of proc. following j     jsplt     = ', jsplt
-         WRITE(numout,*) '             benchmark parameter (0/1)       nbench    = ', nbench
-      ENDIF
-
-      ! ... Control the sub-domain area indices for the control prints
-      IF( ln_ctl )   THEN
-         IF( lk_mpp )   THEN
-            ! the domain is forced to the real splitted domain in MPI
-            isplt = jpni ; jsplt = jpnj ; ijsplt = jpni*jpnj
+         WRITE(numout,*) '   Namelist namctl'
+         WRITE(numout,*) '      run control (for debugging)     ln_ctl     = ', ln_ctl
+         WRITE(numout,*) '      level of print                  nn_print   = ', nn_print
+         WRITE(numout,*) '      Start i indice for SUM control  nn_ictls   = ', nn_ictls
+         WRITE(numout,*) '      End i indice for SUM control    nn_ictle   = ', nn_ictle
+         WRITE(numout,*) '      Start j indice for SUM control  nn_jctls   = ', nn_jctls
+         WRITE(numout,*) '      End j indice for SUM control    nn_jctle   = ', nn_jctle
+         WRITE(numout,*) '      number of proc. following i     nn_isplt   = ', nn_isplt
+         WRITE(numout,*) '      number of proc. following j     nn_jsplt   = ', nn_jsplt
+         WRITE(numout,*) '      benchmark parameter (0/1)       nn_bench   = ', nn_bench
+      ENDIF
+      !
+      nprint    = nn_print          ! convert DOCTOR namelist names into OLD names
+      nictls    = nn_ictls
+      nictle    = nn_ictle
+      njctls    = nn_jctls
+      njctle    = nn_jctle
+      isplt     = nn_isplt
+      jsplt     = nn_jsplt
+      nbench    = nn_bench
+      !                             ! Parameter control
+      !
+      IF( ln_ctl ) THEN                 ! sub-domain area indices for the control prints
+         IF( lk_mpp ) THEN
+            isplt = jpni   ;   jsplt = jpnj   ;   ijsplt = jpni*jpnj   ! the domain is forced to the real splitted domain
          ELSE
             IF( isplt == 1 .AND. jsplt == 1  ) THEN
-               CALL ctl_warn( '          - isplt & jsplt are equal to 1',   &
-                    &         '          - the print control will be done over the whole domain' )
-            ENDIF
-
-            ! compute the total number of processors ijsplt
-            ijsplt = isplt*jsplt
+               CALL ctl_warn( ' - isplt & jsplt are equal to 1',   &
+                  &           ' - the print control will be done over the whole domain' )
+            ENDIF
+            ijsplt = isplt * jsplt            ! total number of processors ijsplt
          ENDIF
-
          IF(lwp) WRITE(numout,*)'          - The total number of processors over which the'
          IF(lwp) WRITE(numout,*)'            print control will be done is ijsplt : ', ijsplt
-
-         ! Control the indices used for the SUM control
-         IF( nictls+nictle+njctls+njctle == 0 )   THEN
-            ! the print control is done over the default area
+         !
+         !                              ! indices used for the SUM control
+         IF( nictls+nictle+njctls+njctle == 0 )   THEN    ! print control done over the default area
             lsp_area = .FALSE.
-         ELSE
-            ! the print control is done over a specific  area
+         ELSE                                             ! print control done over a specific  area
             lsp_area = .TRUE.
             IF( nictls < 1 .OR. nictls > jpiglo )   THEN
@@ -293,34 +259,33 @@
                nictls = 1
             ENDIF
-
             IF( nictle < 1 .OR. nictle > jpiglo )   THEN
                CALL ctl_warn( '          - nictle must be 1<=nictle>=jpiglo, it is forced to jpiglo' )
                nictle = jpiglo
             ENDIF
-
             IF( njctls < 1 .OR. njctls > jpjglo )   THEN
                CALL ctl_warn( '          - njctls must be 1<=njctls>=jpjglo, it is forced to 1' )
                njctls = 1
             ENDIF
-
             IF( njctle < 1 .OR. njctle > jpjglo )   THEN
                CALL ctl_warn( '          - njctle must be 1<=njctle>=jpjglo, it is forced to jpjglo' )
                njctle = jpjglo
             ENDIF
-
-         ENDIF          ! IF( nictls+nictle+njctls+njctle == 0 )
-       ENDIF            ! IF(ln_ctl)
-
-      IF( nbench == 1 )   THEN
+         ENDIF
+      ENDIF
+      !
+      IF( nbench == 1 )   THEN            ! Benchmark 
          SELECT CASE ( cp_cfg )
-         CASE ( 'gyre' )
-            CALL ctl_warn( '          The Benchmark is activated ' )
-         CASE DEFAULT
-            CALL ctl_stop( '          The Benchmark is based on the GYRE configuration: key_gyre must &
-               &                      be used or set nbench = 0' )
+         CASE ( 'gyre' )   ;   CALL ctl_warn( ' The Benchmark is activated ' )
+         CASE DEFAULT      ;   CALL ctl_stop( ' The Benchmark is based on the GYRE configuration:',   &
+            &                                 ' key_gyre must be used or set nbench = 0' )
          END SELECT
       ENDIF
-
-   END SUBROUTINE opa_flg
+      !
+      IF( lk_c1d .AND. .NOT.lk_iomput )   CALL ctl_stop( 'opa_ctl: The 1D configuration must be used ',   &
+         &                                               'with the IOM Input/Output manager. '        ,   &
+         &                                               'Compile with key_iomput enabled' )
+      !
+   END SUBROUTINE opa_ctl
+
 
    SUBROUTINE opa_closefile
@@ -329,24 +294,15 @@
       !!
       !! ** Purpose :   Close the files
-      !!
-      !! ** Method  :
-      !!
-      !! History :
-      !!   9.0  !  05-01  (O. Le Galloudec)  Original code
-      !!----------------------------------------------------------------------
-      !!----------------------------------------------------------------------
-
+      !!----------------------------------------------------------------------
+      !
       IF ( lk_mpp ) CALL mppsync
-
-      ! 1. Unit close
-      ! -------------
-
-      CLOSE( numnam )           ! namelist
-      CLOSE( numout )           ! standard model output file
-
-      IF(lwp) CLOSE( numstp )   ! time-step file
-
-      CALL iom_close            ! close all input/output files
-
+      !
+      CALL iom_close                                 ! close all input/output files managed by iom_*
+      !
+      IF( numstp     /= -1 )   CLOSE( numstp     )   ! time-step file
+      IF( numnam     /= -1 )   CLOSE( numnam     )   ! oce namelist
+      IF( numout     /=  6 )   CLOSE( numout     )   ! standard model output file
+      numout = 6                                     ! redefine numout in case it is used after this point...
+      !
    END SUBROUTINE opa_closefile
 
Index: trunk/NEMOGCM/NEMO/OFF_SRC/stpctl.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OFF_SRC/stpctl.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OFF_SRC/stpctl.F90	(revision 2528)
@@ -1,12 +1,17 @@
 MODULE stpctl
-   !!==============================================================================
+   !!======================================================================
    !!                       ***  MODULE  stpctl  ***
-   !! Ocean run control :  gross check of the ocean time stepping
-   !!==============================================================================
+   !! Ocean run control :  Off-line case, only save the time step in numstp
+   !!======================================================================
+   !! History :  OPA  ! 1991-03  (G. Madec) Original code
+   !!            6.0  ! 1992-06  (M. Imbard)
+   !!            8.0  ! 1997-06  (A.M. Treguier)
+   !!   NEMO     1.0  ! 2002-06  (G. Madec)  F90: Free form and module
+   !!            2.0  ! 2009-07  (G. Madec)  Add statistic for time-spliting
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
    !!   stp_ctl      : Control the run
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables 
@@ -18,11 +23,14 @@
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC stp_ctl           ! routine called by step.F90
+   PUBLIC   stp_ctl    ! routine called by opa.F90
+   
    !!----------------------------------------------------------------------
-
+   !! NEMO/OFF 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
-   SUBROUTINE stp_ctl( kt )
+   SUBROUTINE stp_ctl( kt, kindic )
       !!----------------------------------------------------------------------
       !!                    ***  ROUTINE stp_ctl  ***
@@ -31,24 +39,11 @@
       !!
       !! ** Method  : - Save the time step in numstp
-      !!              - Print it each 50 time steps
-      !!              - Print solver statistics in numsol 
-      !!              - Stop the run IF problem for the solver ( indec < 0 )
       !!
-      !! History :
-      !!        !  91-03  ()
-      !!        !  91-11  (G. Madec)
-      !!        !  92-06  (M. Imbard)
-      !!        !  97-06  (A.M. Treguier)
-      !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
+      !! ** Actions :   'time.step' file containing the last ocean time-step
       !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt         ! ocean time-step index
-
+      INTEGER, INTENT(in   ) ::   kt      ! ocean time-step index
+      INTEGER, INTENT(inout) ::   kindic  ! indicator of solver convergence
       !!----------------------------------------------------------------------
-      !!   OPA 9.0 , LOCEAN-IPSL  (2005)
-      !!   $Id$
-      !!   This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
-      !!----------------------------------------------------------------------
-
+      !
       IF( kt == nit000 .AND. lwp ) THEN
          WRITE(numout,*)
@@ -56,14 +51,10 @@
          WRITE(numout,*) '~~~~~~~'
          ! open time.step file
-         CALL ctlopn( numstp, 'time.step', 'UNKNOWN', 'FORMATTED', 'SEQUENTIAL', 1, numout, lwp, 1 )
+         CALL ctl_opn( numstp, 'time.step', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp, narea )
       ENDIF
-
-      ! save the current time step in numstp
-      ! ------------------------------------
-      IF(lwp) WRITE(numstp,9100) kt
-      IF(lwp) REWIND(numstp)
-9100  FORMAT(1x, i8)
-
-
+      !
+      IF(lwp) WRITE ( numstp, '(1x, i8)' )   kt      !* save the current time step in numstp
+      IF(lwp) REWIND( numstp )                       !  --------------------------
+      !
    END SUBROUTINE stp_ctl
 
